VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public View As cfLayoutView
Public WithEvents Form As cWidgetForm 'this cfMain-Class here encapsulates a cWidgetForm and its Events
Attribute Form.VB_VarHelpID = -1

Private Sub Class_Initialize()
  Set View = Cairo.CreateLayoutView(CreatePanelLayoutView, "SQLite/vbWidgets-Demo", vbSizable, 860, 645)

  Set Form = View.Form 'set a Reference to the internal View-Form, to receive Form-Events in this Class here
      Form.SetMinMaxDimensions 800, 600 'let's just restrict the minimal Form-Dimensions to 640x480 Pixel
      Form.BackColor = &HBBBBBB
      Form.IconImageKey = "Logo"
  
  View.SwitchToLayout "Panel-LayoutView1"

  View.PanelByKey("pnlLeft")!tvwLetters.ListIndex = 1
End Sub
 
Private Sub Form_ResizeWithDimensions(ByVal NewWidth As Long, ByVal NewHeight As Long)
  View.PanelByKey("pnlRight")!Resizer.Init 1, NewWidth * 0.4, , NewWidth * (1 - 0.3)

  View.CurLayout.ResizeOnParent 0, 0, NewWidth, NewHeight 'only this line here is needed, to ensure proper dynamic resizing of the Sub-Panels
End Sub
 
Private Sub Form_BubblingEvent(Sender As Object, EventName As String, P1 As Variant, P2 As Variant, P3 As Variant, P4 As Variant, P5 As Variant, P6 As Variant, P7 As Variant)
Dim W As cWidgetBase, WObj As Object
  Set W = Sender.Widget
 
  If EventName = "AddInitialWidgetsToPanel" Then
    AddInitialWidgetsToPanel Sender

  ElseIf EventName = "ResizeWithDimensions" Then
    If Sender.Key = "pnlLeft" Then
      W.Widgets("tvwLetters").Widget.Move -1, -1, P1 + 1, P2 + 2
      W.Widgets("tvwTypes").Widget.Move -1, -1, P1 + 1, P2 + 2
      W.Widgets("cntSearch").Widget.Move -1, -1, P1 + 1, P2 + 2

    ElseIf Sender.Key = "pnlRight" Then
      W.Widgets("cntDetails").Widget.Move 11, 6, P1 - 21, P2 - 16
      
    ElseIf Sender.Key = "pnlStatusBar" Then
      W.Widgets("StatusBar").Widgets("btnExit").Widget.Move P1 - 105, 13
    End If

  ElseIf Left(W.Key, 3) = "tab" Then 'tab-strip-Handling happens here in this section
    
    If EventName = "W_MouseEnter" Or EventName = "W_MouseLeave" Then 'just some Lock-Refresh-Handling on MouseEnter/Leave
      For Each WObj In W.Parent.Widgets
        WObj.Widget.CanGetFocus = IIf(EventName = "W_MouseLeave", True, False)
      Next
      View.PanelByKey("pnlLeft").Widget.Root.LockRefresh = IIf(EventName = "W_MouseEnter", True, False)
 
    ElseIf EventName = "Click" And Not View.PanelByKey("pnlLeft").Panel Is Nothing Then 'tab-Click-handling
      
      For Each WObj In W.Parent.Widgets 'this loops over the three tab-strip-buttons (swapping styles around)
        WObj.Widget.FontBold = IIf(Sender Is WObj, True, False)
        WObj.Widget.Alpha = IIf(Sender Is WObj, 1, 0.3)
        WObj.Widget.HoverColor = IIf(Sender Is WObj, vbWhite, RGB(140, 225, 255)) 'Cairo.Theme.GetThemeColor(thmSelectionColor))
        WObj.Widget.Move WObj.Widget.Left, IIf(Sender Is WObj, 4, 6), WObj.Widget.Width, IIf(Sender Is WObj, 28, 25)
      Next
 
      Set View.PanelByKey("pnlRight")!cntDetails.DataSource = Nothing
      View.PanelByKey("pnlLeft").Panel.SetFocus
      
      For Each WObj In View.PanelByKey("pnlLeft").Widgets 'this loops over the accompanying 3-Widgets in the Left-Panel, directly below the tab-buttons
        WObj.Widget.Visible = False
        If Mid(WObj.Widget.Key, 4) = Mid(W.Key, 4) Then
          WObj.Widget.Visible = True: WObj.Widget.SetFocus
          If TypeName(WObj) = "cwTree" Then UpdateStatusWithInfoFrom WObj.DataSource
        End If
      Next
      View.PanelByKey("pnlLeft").Widget.Root.LockRefresh = False
    End If
  
  ElseIf EventName = "W_KeyDown" And W.Key = "tvwLetters" Then 'scroll the Letter-Node in question into view and expand it (if there is one)
    If Not dsLetters.TreeRoot.Exists(Chr$(P1)) Then Exit Sub
    dsLetters.TreeNodeExpand dsLetters.TreeRoot(Chr$(P1))
    Sender.ListIndex = dsLetters.TreeNodeGetVisibleIndex(dsLetters.TreeRoot(Chr$(P1)))
    Sender.VList.ScrollIndex = Sender.ListIndex
    
  ElseIf EventName = "Click" And Left(W.Key, 3) = "tvw" Then
    UpdateStatusWithInfoFrom W.object.DataSource
  
  ElseIf EventName = "OwnerDrawItem" And Left(W.Key, 3) = "tvw" Then
    RenderTreeItems W.object, P1, P2, P3, P4, P5
  
  ElseIf EventName = "OwnerDrawOnTop" And W.Key = "StatusBar" Then 'just a bit of "cosmetics" around the StatusBar-Label
    P1.RenderSurfaceContent "Info", 12, 11.7, W.Height - 21, W.Height - 21 'the Info-Icon
    P1.SetSourceColor vbBlack, 0.37 'a rounded Rectangle with 37% Alpha
      P1.RoundedRect 6, 7, 353, 36, 4.5, True
    P1.Stroke
    P1.SetLineWidth 2: P1.SetLineCap Cairo_LINE_CAP_ROUND 'and a "ShadowLine" with 15% Alpha below the Rectangle
      P1.SetSourceColor vbBlack, 0.15
      P1.DrawLine 11, W.Height - 6.5, 353, W.Height - 6.5, True
    P1.Stroke

  ElseIf EventName = "Click" And W.Key = "btnExit" Then
    Form.Unload
  End If
End Sub
 
Private Sub UpdateStatusWithInfoFrom(DS As cDataSource)
Dim FullPath As String, Value, Key, ParentNode As cCollection
  If Not DS.TreeElementInfoByVisibleIndex(DS.AbsolutePosition - 1, Key, Value, , , ParentNode) Then Exit Sub
 
  If TypeOf Value Is cCollection Then
    FullPath = DS.TreeNodeFullPath(Value)
    Set View.PanelByKey("pnlRight")!cntDetails.DataSource = Nothing
  Else 'in case of a "Non-Node" (a plain ValueItem), ...
    FullPath = DS.TreeNodeFullPath(ParentNode) '...we need to use its ParentNode to retrieve the "Path-leading-to-it"
    FullPath = FullPath & IIf(Len(FullPath), "\", "") & Key & IIf(Len(Value), " (Value=" & Value & ")", "")
    Set View.PanelByKey("pnlRight")!cntDetails.DataSource = getDetailDataUpdate(Value)
  End If

  View.PanelByKey("pnlStatusBar")(1).Widgets("lblStatus").Caption = "last clicked Fullpath -> " & FullPath
End Sub
 
'...here we go with the generic Tree-Rendering
Private Sub RenderTreeItems(tv As Object, ByVal Index As Long, ByVal CC As cCairoContext, ByVal dx As Single, ByVal dy As Single, ByVal Alpha As Single)
'define your Base-Offsets for indentation in the consts below
Const BaseOffsX As Long = 17, Indent As Long = 16, ArrowSize As Long = 8, IconSize As Long = 16

'all the Vars defined below, will get filled (ByRef) in the TreeElementInfo-call which follows
Dim Key, Value, Expanded As Boolean, Level As Long '<-
  If Not tv.DataSource.TreeElementInfoByVisibleIndex(Index, Key, Value, Expanded, Level) Then Exit Sub

'Ok ... it's drawing-time
Dim x As Long
  x = BaseOffsX + (Level + 1) * Indent

  If TypeOf Value Is cCollection Then 'we have a Node-Entry
    If Index > tv.VList.ScrollIndex Then CC.DrawLine BaseOffsX * 0.66, 0, dx - 9, 0, True, 1, &HD0D0D0, 0.5
    tv.DrawArrow CC, Index, x - IconSize - ArrowSize * 1.5, ArrowSize, Expanded, Value.Count 'any Node gets a small Triangle drawn, using a Helper-Function in cwTree
    CC.RenderSurfaceContent Mid(tv.Widget.Key, 4) & IIf(Expanded And Value.Count > 0, "Opened", "Closed"), x - IconSize - 1, (dy - IconSize) \ 2, IconSize, IconSize
    tv.Widget.FontBold = True

  Else 'we have a normal Item-Entry (not a Node - and so we draw no Arrow)
    CC.RenderSurfaceContent "Doc", x - IconSize - 1, (dy - IconSize) \ 2, IconSize, IconSize
    tv.Widget.FontBold = False
  End If
  
  tv.Widget.SelectFontSettingsInto CC
  CC.DrawText x, 0, dx - x, dy, CStr(Key), True, vbLeftJustify, 3, True

  tv.Widget.FontBold = True 'reset the FontBold-settings
End Sub
