VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cwSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
 
Private mCaption As String
Private WithEvents mDS As cDataSource
Attribute mDS.VB_VarHelpID = -1

Private WithEvents W As cWidgetBase
Attribute W.VB_VarHelpID = -1

Private Sub Class_Initialize()
  Set W = Cairo.WidgetBase
      W.ForwardFocus = True
      W.BackColor = vbWhite
      W.FontBold = True
      
  Widgets.Add(WCreate("cwTextBox"), "txtSearch").CueBannerText = "type your search-string here"
      
  With Widgets.Add(WCreate("cwDropDownList"), "cmbTypes")
        .Widget.ImageKey = "TypesOpened"
        .Widget.Alpha = 0.8
    Set .DataSource = dsTypesCol
        .ListIndex = 0
  End With
  
  With Widgets.Add(WCreate("cwGrid"), "grdResults")
    Set mDS = New_c.DataSource
        mDS.Init Cnn.OpenRecordset("Select itemno,typeno,itemdesc From tblItems Where 0"), "rsItems"
    Set .DataSource = mDS
        .ColumnWidth(0) = 0
        .ColumnWidth(1) = 0
  End With
End Sub

Public Property Get Widget() As cWidgetBase
  Set Widget = W
End Property
Public Property Get Widgets() As cWidgets
  Set Widgets = W.Widgets
End Property
 
Public Property Get Caption() As String
  Caption = mCaption
End Property
Public Property Let Caption(ByVal NewValue As String)
  If mCaption = NewValue Then Exit Property
  mCaption = NewValue
  W.Refresh
End Property
 
'the following Events (as well as the 'DoSearch'-Routine below) handle all the SearchResult-Refresh-Actions
Private Sub W_EnterFocus()
  DoSearch dsTypesCol("Value")
  Widgets("txtSearch").SelStart = 0
  Widgets("txtSearch").SelLength = 10000
End Sub
Private Sub W_BubblingEvent(Sender As Object, EventName As String, P1 As Variant, P2 As Variant, P3 As Variant, P4 As Variant, P5 As Variant, P6 As Variant, P7 As Variant)
  If EventName = "Change" Or (Sender.Widget.Key = "cmbTypes" And EventName = "Click") Then
    If Not mDS Is Nothing Then DoSearch dsTypesCol("Value")
  End If
End Sub
Private Sub mDS_Move(ByVal NewRowIdxZeroBased As Long)
  If Not mDS.BOF Then Set fMain.View.PanelByKey("pnlRight")!cntDetails.DataSource = getDetailDataUpdate(mDS("itemNo"))
End Sub

Private Sub DoSearch(ByVal typeNo As Long)
Dim SQL As String, typePart As String, S As String
  S = Widgets("txtSearch").Text
  Set fMain.View.PanelByKey("pnlRight")!cntDetails.DataSource = Nothing
  If typeNo Then typePart = " typeno=" & typeNo & " And "
  SQL = "Select itemno,typeno,itemdesc From tblItems Where " & typePart & " itemdesc like '" & S & "%'"
  If mDS.Rs.SQL <> SQL Then
     mDS.Rs.SQL = SQL
     mDS.Rs.ReQuery
     mDS.Sort = "itemdesc Asc"
     Widgets("grdResults").ResetSortStates
  End If
  mDS_Move 0
  fMain.View.PanelByKey("pnlStatusBar")(1).Widgets("lblStatus").Caption = "Searchstring: " & S & vbCrLf & "Records found: " & mDS.RecordCount
End Sub

'the rest of the Event-Handlers here, is just related to our container-Widget (cwSearch)
Private Sub W_Resize() 'resizing of our 3 internal Controls
  Widgets("cmbTypes").Widget.Move 12, 38, W.ScaleWidth - 24, 24
  Widgets("txtSearch").Widget.Move 12, 70, W.ScaleWidth - 24, 24
  Widgets("grdResults").Widget.Move 12, 120, W.ScaleWidth - 24, W.ScaleHeight - 132
End Sub
 
Private Sub W_Paint(CC As vbRichClient5.cCairoContext, ByVal xAbs As Single, ByVal yAbs As Single, ByVal dx_Aligned As Single, ByVal dy_Aligned As Single, UserObj As Object)
Dim dx As Single, dy As Single
  CC.SetSourceColor W.BackColor, W.Alpha
  CC.Paint

  'draw the Header-Gradient
  dx = dx_Aligned: dy = 28
  Cairo.Theme.DrawTo CC, W, thmTypeButtonFace, 0, -1, -2, dx + 3, dy + 4, 1, thmDirectionDown
  Cairo.Theme.DrawTo CC, W, thmTypeShine, 0, 0, -1, dx, Int((dy + 2) \ 2) - 1, 0, thmDirectionDown
  CC.DrawLine 0, dy, dx, dy, True, 1, W.BorderColor, 0.3
  'draw the Header-Caption
  W.SelectFontSettingsInto CC
  CC.DrawText 4, 1, dx, dy, mCaption, True, vbLeftJustify, 2, True
  
  'draw the static Label-Text (we don't need to waste a cwLabel-Widget for that)
  CC.TextOut 12, 103, "Search-Results"
  
  'draw the Border
  CC.SetLineWidth 1, True
  Cairo.Theme.DrawTo CC, W, thmTypeBorder, 0, 0, 0, dx_Aligned, dy_Aligned
End Sub
 
