Attribute VB_Name = "modDBLayer"
Option Explicit
 
Public DBPath As String, Cnn As cConnection
Public dsLetters As cDataSource, dsTypes As cDataSource, dsTypesCol As cDataSource
 
Public Sub ConvertMDBtoSQLite(SrcPath As String, DstPath As String)
Dim DstCnn As cConnection, SrcCnn As Object 'we define a temporary ADODB.Connection LateBound...
  Set SrcCnn = CreateObject("ADODB.Connection") 'as our Source-Connection for the Import
      SrcCnn.CursorLocation = 3 'adUseClient
      SrcCnn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & SrcPath
  
  'now we create a new, empty SQLite-Connection for the new DB3-SQLite-FileFormat as the Destination
  Set DstCnn = New_c.Connection(DstPath, DBCreateNewFileDB)
  
  With New_c.Converter 'use the RC5-cConverter-Class, to import from our ADO-SrcCnn into the SQLite-DstCnn
    .CaseInSensitive_TextColumns = True
    .ConvertDatabase SrcCnn, DstCnn
    .ConvertIndexes SrcCnn, DstCnn
  End With
End Sub

Public Sub InitDataSources()
  Set Cnn = New_c.Connection(DBPath & "mdbTree.db3", DBOpenFromFile)  'open the SQLite-Cnn from an existing File
  
  Dim RsItems As cRecordset 'note, that we will fill our tree-datasources without using any Sort or Filter-Conditions in the 2 Selects
  Set RsItems = Cnn.OpenRecordset("Select itemno,itemdesc,typeno from tblItems")

'  If RsItems.RecordCount < 5000 Then Add5000TestRecordsTo RsItems ''just in case, one want's to see the performance for a larger amount of Tree-Records
  InitLetterTreeDS RsItems
  InitTypeTreeDS RsItems, Cnn.OpenRecordset("Select typeno,typedesc from tblType")
End Sub

Private Sub Add5000TestRecordsTo(RsItems As cRecordset) 'uncomment the appropriate line in the routine above, to see the performance on a "heavier" DB-ItemSet
Dim i As Long
  For i = 1 To 5000
    RsItems.AddNew
    RsItems(0) = i + 30
    RsItems(1) = Chr(65 + Int(Rnd * 26)) & " ... one of 5000 TestRecords"
    RsItems(2) = 1 + Int(Rnd * 10) 'we evenly distribute over our 10 different type-numbers
  Next i
  RsItems.UpdateBatch
End Sub

Public Sub InitLetterTreeDS(RsItems As cRecordset)
Dim i As Long, itemDesc As String, Char As String, Node As cCollection
  Set dsLetters = New_c.DataSource 'create a new, empty DataSource
      dsLetters.Init New_c.Collection(False), "dsLetters", , True  'set the Container-Type of our DataSource
      dsLetters.Sort = "Key Asc"
 
  For i = 0 To RsItems.RecordCount - 1
    itemDesc = RsItems.ValueMatrix(i, 1)
    If Len(itemDesc) = 0 Then Char = "#" Else Char = UCase$(Left$(itemDesc, 1))
    If dsLetters.TreeRoot.Exists(Char) Then
      Set Node = dsLetters.TreeRoot(Char) 'use the existing Node for this current Char
    Else 'create a new (Parent-) Node
      Set Node = dsLetters.TreeNodeAdd(dsLetters.TreeRoot, Char)
    End If
    Node.Add RsItems.ValueMatrix(i, 0), itemDesc
  Next i
   
  dsLetters.TreeNodeExpand dsLetters.TreeRoot, True, True '<- we set the Expand-Attribute on all Nodes (from the DS-Root, using the optional DeepExpand-Param)
End Sub
 
Public Sub InitTypeTreeDS(RsItems As cRecordset, RsTypes As cRecordset)
Dim i As Long, Dict As cSortedDictionary, Col As cCollection, typeDesc As String, Node As cCollection
  'cover the types in dedicated structures first
  Set Dict = New_c.SortedDictionary(TextCompare)
  Set Col = New_c.Collection(False)
  For i = 0 To RsTypes.RecordCount - 1 'for a fast (non-DB) Lookup from TypeNo to TypeDesc...
    Dict.Add RsTypes.ValueMatrix(i, 0), RsTypes.ValueMatrix(i, 1) 'we store the Rs-Values in Dict with typeNo as the Key (fast lookup in the following loop)
    Col.Add RsTypes.ValueMatrix(i, 0), RsTypes.ValueMatrix(i, 1) 'but also in Col with typeDesc as the Key and typeNo as the Value
  Next i
  Col.Add 0, "<all type-categories>" 'just one more entry, since we will wrap this as our search-combo-datasource (in dsTypesCol as a global Var)
  Set dsTypesCol = New_c.DataSource
      dsTypesCol.Init Col, "dsTypesCol"
      dsTypesCol.Sort = "Key Asc"
  
  'Ok, now the large loop, to build up our Types-Tree in dsTypes (the above was only covering the type-categories)
  Set dsTypes = New_c.DataSource 'create a new, empty DataSource
      dsTypes.Init New_c.Collection(False), "dsTypes", , True 'set the Container-Type of our DataSource
      dsTypes.Sort = "Key Asc"
  
  For i = 0 To RsItems.RecordCount - 1
    typeDesc = Dict(RsItems.ValueMatrix(i, 2))  'here we do the fast Lookup over the Collection (per typeNo as Key)
    If dsTypes.TreeRoot.Exists(typeDesc) Then
      Set Node = dsTypes.TreeRoot(typeDesc) 'use the existing Node for this current typeDesc-String
    Else 'create a new (Parent-) Node
      Set Node = dsTypes.TreeNodeAdd(dsTypes.TreeRoot, typeDesc)
    End If
    Node.Add RsItems.ValueMatrix(i, 0), RsItems.ValueMatrix(i, 1)
  Next i
  
  dsTypes.TreeNodeExpand dsTypes.TreeRoot, True, True '<- we set the Expand-Attribute on all Nodes (from the DS-Root, using the optional DeepExpand-Param)
End Sub
 
Public Function getDetailDataUpdate(ByVal ItemNo As Long) As cDataSource
  Set getDetailDataUpdate = New_c.DataSource 'create a new, empty DataSource
      getDetailDataUpdate.Init Cnn.OpenRecordset( _
         "Select itemno, (Select typedesc From tblType Where tblType.typeno=tblItems.typeno), itemdesc, um, unitprice from tblItems where itemNo=" & ItemNo), "Details"
End Function
