Attribute VB_Name = "modMain"
Option Explicit

'The demo here re-implements a "VB-beginners"-Demo from PSC (involving CommonControls, Trees and ADO/JET usage)
'with appropriate alternatives from the RichClient-Framework (SQLite for ADO/JET and vbWidgets for the CommonControls).
'Just to have a relatively simple example available, which doesn't as much focus on demonstrating certain RC5-classes
'or the features of a few single vbWidgets - instead it takes up the gist of the original Demos Author: "Let's write a
'small, but relatively complete Application" (covering a typical scenario ... or a "typical screen").
'The original Demo can be found here:
'http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=35601&lngWId=1

Private Declare Function LoadLibraryA Lib "kernel32" (ByVal lpLibFileName As String) As Long
Private Declare Function GetInstanceEx Lib "DirectCom" (StrPtr_FName As Long, StrPtr_ClassName As Long, ByVal UseAlteredSearchPath As Boolean) As Object
 
Public New_c As cConstructor, Cairo As cCairo, fMain As New cfMain

Sub Main()
  InitRegfreeMode App.Path & "\RC5Bin\"
  
  Cairo.SetDPIAwareness

  AddImageResourcesFromFolder New_c.FSO.GetDirList(App.Path & "\Res\")
    
  DBPath = App.Path & "\DBs\"
    If Not New_c.FSO.FileExists(DBPath & "mdbTree.db3") Then ' in case, the *.mdb was not yet converted...
      ConvertMDBtoSQLite DBPath & "mdbTree.mdb", DBPath & "mdbTree.db3" '...we do so here
    End If
  InitDataSources

  fMain.Form.Show
  
  Cairo.WidgetForms.EnterMessageLoop
End Sub

Private Sub InitRegfreeMode(BinPath As String)
  If App.LogMode = 0 Then 'we run in the IDE
    Set New_c = New cConstructor 'so we can instantiate normally
  Else
    LoadLibraryA BinPath & "DirectCOM.dll" 'preload DirectCOM.dll from Bin-Path
    Set New_c = GetInstanceEx(StrPtr(BinPath & "vbRichClient5.dll"), StrPtr("cConstructor"), True)
  End If
  
  Set Cairo = New_c.Cairo 'now we can retrieve "everything else" (also regfree) over New_c (as e.g. our global Cairo-Variable here)
End Sub

'BTW, some nice Icons (LGPL) can be found here: http://commons.wikimedia.org/wiki/Crystal_Clear
Private Sub AddImageResourcesFromFolder(DL As cDirList)
Dim i As Long, Key As String
  For i = 0 To DL.FilesCount - 1
    Key = Left$(DL.FileName(i), InStrRev(DL.FileName(i), ".") - 1)
    Cairo.ImageList.AddImage Key, DL.Path & DL.FileName(i)
  Next i
End Sub
