Attribute VB_Name = "modWidgetConstruction"
Option Explicit

'a Helper-Function for LateBound-Widget-Loading (As Object)
'The whole Demo is based on LateBound-WidgetHandling, due to its regfree nature, ...
'but also because vbWidgets.dll is not yet switched to a Binary-Compatible and stable Interface
'There's constantly new additions to vbWidgets.dll, though existing functionality will not be broken -
'so this Demo here will work further without problems, also with future versions of vbWidgets.dll
Public Function WCreate(TypeName As String) As Object
  If App.LogMode = 0 Then 'we run in the IDE
    Set WCreate = CreateObject("vbWidgets." & TypeName) 'so we can instantiate normally
  Else 'Ok, when running within the Binary, we instantiate our Widgets regfree
    Set WCreate = New_c.RegFree.GetInstanceEx(App.Path & "\RC5Bin\vbWidgets.dll", TypeName)
  End If
End Function

'Ok, here our Widget-Construction-routine (triggered by the Form_Bubbling-Event: "AddInitialWidgetsToPanel")
'... later on, all these Widget-construction-lines will be more hidden to the user, either due to XML-Loading,
'or by constructing real Widget-Add-Code (like the one below) automatically, by the new Form-Designer.
Public Sub AddInitialWidgetsToPanel(PanelDef As cPanelDef)
'Dim tvw As cwTree, btn As cwButton, lbl As cwLabel, tlb As cwToolBar, frm As cwFrame
Dim tvw As Object, btn As Object, lbl As Object, tlb As Object, frm As Object
  Select Case PanelDef.Key
    Case "pnlTop"
      Set tlb = PanelDef.Widgets.Add(WCreate("cwToolBar"), "tbGradient", , , 1, PanelDef.dy)
          tlb.Widget.BackColor = &HBBBBBB
          tlb.AllowGripperDrawing = False
          tlb.Widgets.Add(WCreate("cwImage"), "Logo", 5, 2, 44, 44).Widget.ImageKey = "Logo"
          Set lbl = tlb.Widgets.Add(WCreate("cwLabel"), "lblMotto1", 52, -11, 150, Abs(PanelDef.dy))
              lbl.Widget.ForeColor = RGB(66, 144, 255)
              lbl.Widget.FontSize = 13
              lbl.Widget.FontBold = True
              lbl.Widget.FontItalic = True
   
              lbl.TextShadowColor = RGB(144, 178, 255)
              lbl.TextShadowOffsetX = 0.95
              lbl.TextShadowOffsetY = 1.25
    
              lbl.BorderWidth = 0
              lbl.Widget.BackColor = -1
              lbl.Caption = "vbWidgets"
              
          Set lbl = tlb.Widgets.Add(WCreate("cwLabel"), "lblMotto2", 70, 6, 250, Abs(PanelDef.dy))
              lbl.Widget.ForeColor = RGB(77, 195, 79)
              lbl.Widget.FontBold = True
              lbl.Widget.FontItalic = True
  
              lbl.TextShadowColor = RGB(159, 212, 155)
              lbl.TextShadowOffsetX = 2
              lbl.TextShadowOffsetY = 1
    
              lbl.BorderWidth = 0
              lbl.Widget.BackColor = -1
              lbl.Caption = "...a modern GUI-approach for VBClassic"
 
    Case "pnlLeft"
      Set tvw = PanelDef.Widgets.Add(WCreate("cwTree"), "tvwLetters", 0, 0, 350, 100)  'create the Tree-Widget
          tvw.VList.HeaderHeight = 28
          tvw.Caption = "Letter-based detail-presentation"
      Set tvw.DataSource = dsLetters 'here we connect our DataSource-Container with the Widget

      Set tvw = PanelDef.Widgets.Add(WCreate("cwTree"), "tvwTypes", 0, 0, 350, 100, False)  'create the Tree-Widget
          tvw.VList.HeaderHeight = 28
          tvw.Caption = "Type-based detail-presentation"
      Set tvw.DataSource = dsTypes 'here we connect our DataSource-Container with the Widget
 
      PanelDef.Widgets.Add(New cwSearch, "cntSearch", 0, 0, 350, 100, False).Caption = "Search for details in type-categories"
 
    Case "pnlRight"
      PanelDef.Widgets.Add WCreate("cwResizer"), "Resizer" 'create a Resizer-Splitter on the jsTree-Widget
      PanelDef.Widgets.Add New cwDetail, "cntDetails", 6, 6, 111, 111
 
    Case "pnlToolBar" 'we add a cwToolBar (and 3 Option-Buttons into the ToolBar-Panel)
      Set tlb = PanelDef.Widgets.Add(WCreate("cwToolBar"), "ToolBar", , , 1, PanelDef.dy)
          
        Set btn = tlb.Widgets.Add(WCreate("cwButton"), "tabLetters", 12, 4, 77, 28)
            btn.Caption = "&Letters"
            btn.Widget.ToolTip = "Letters"
            btn.Widget.ImageKey = "LettersOpened"
            btn.Widget.FontBold = True
            btn.Widget.HoverColor = vbWhite  'RGB(140, 225, 255)
            btn.Widget.Alpha = 1
            
            btn.ButtonStyle = 5 'OptionButton
            btn.BorderRadius = 2
            btn.Widget.BackColor = vbWhite
            btn.Widget.SelectionColor = btn.Widget.BorderColor
            btn.DownStateCaptionOffset = 0
            btn.Value = True 'make this the default-button

        Set btn = tlb.Widgets.Add(WCreate("cwButton"), "tabTypes", 88, 6, 69, 25)
            btn.Caption = "&Types"
            btn.Widget.ToolTip = "Types"
            btn.Widget.ImageKey = "TypesOpened"
            btn.Widget.HoverColor = RGB(140, 225, 255)
            btn.Widget.Alpha = 0.3
 
            btn.ButtonStyle = 5 'OptionButton
            btn.BorderRadius = 2
            btn.Widget.BackColor = vbWhite
            btn.Widget.SelectionColor = btn.Widget.BorderColor
            btn.DownStateCaptionOffset = 0

        Set btn = tlb.Widgets.Add(WCreate("cwButton"), "tabSearch", 156, 6, 80, 25)
            btn.Caption = "&Search"
            btn.Widget.ToolTip = "Search"
            btn.Widget.ImageKey = "Search"
            btn.Widget.HoverColor = RGB(140, 225, 255)
            btn.Widget.Alpha = 0.3
 
            btn.ButtonStyle = 5 'OptionButton
            btn.BorderRadius = 2
            btn.Widget.BackColor = vbWhite
            btn.Widget.SelectionColor = btn.Widget.BorderColor
            btn.DownStateCaptionOffset = 0

    Case "pnlStatusBar" 'we add a cwStatusBar (and a Label into the StatusBar-Panel)
      With PanelDef.Widgets.Add(WCreate("cwStatusBar"), "StatusBar", , , -1, Abs(PanelDef.dy))
        .Widget.BackColor = &HBBBBBB
        Set lbl = .Widgets.Add(WCreate("cwLabel"), "lblStatus", 44, 7, 310, Abs(PanelDef.dy) - 13)
            lbl.TextShadowColor = &H909090
            lbl.TextShadowOffsetX = 2
            lbl.TextShadowOffsetY = 1
            lbl.BorderWidth = 0
            lbl.WordWrap = True
            lbl.Widget.BackColor = -1 'fully transparent (no) BackColor
      
        Set btn = .Widgets.Add(WCreate("cwButton"), "btnExit", 222, 4, 95, 24)
            btn.Caption = "E&xit Dialog"
            btn.ImageSize = 18
            btn.BorderRadius = 2.5
            btn.Widget.ImageKey = "AppExit"
            btn.Widget.BackColor = &H1144E0
            btn.Widget.HoverColor = &H1149EE
            btn.Widget.FocusColor = &H113399
      End With
      
  End Select
End Sub

